Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Based_Pointer Class Template Reference

A smart proxy that keeps track of the relative offset of a "pointer" from its base address. More...

`#include <Based_Pointer_T.h>`

Inheritance diagram for ACE_Based_Pointer:

[legend]
Collaboration diagram for ACE_Based_Pointer:

[legend]
List of all members.

## Public Methods
| ACE_Based_Pointer (void)
| Constructor. See constructor for <ACE_Based_Pointer_Basic> for details. More...
| ACE_Based_Pointer (CONCRETE *initial)
| Initialize this object using the <initial> pointer. See constructor for <ACE_Based_Pointer_Basic> for details. More...
| ACE_Based_Pointer (const void *base_addr, int dummy)
| Initialize this object with known <base_addr>. <dummy> is a dummy value used to resolve overload ambiguity and it otherwise ignored. More...
| ACE_Based_Pointer (const ACE_Based_Pointer< CONCRETE > &)
| Copy constructor (not implemented yet). More...
void | operator= (const ACE_Based_Pointer< CONCRETE > &)
| Assignment operator. More...
void | operator= (CONCRETE *from)
| Pseudo-assignment operator. More...
CONCRETE * | operator-> (void)
| The C++ "delegation operator". More...

## Detailed Description

### template<class CONCRETE>
class ACE_Based_Pointer< CONCRETE >

A smart proxy that keeps track of the relative offset of a "pointer" from its base address.

This class makes it possible to transparently use "pointers" in shared memory as easily as programming with pointers to local memory by overloading the C++ delegation operator->().

## Constructor & Destructor Documentation

template<class CONCRETE>
ACE_Based_Pointer< CONCRETE >::ACE_Based_Pointer | ( | void |  | ) |

| Constructor. See constructor for <ACE_Based_Pointer_Basic> for details.

template<class CONCRETE>
ACE_Based_Pointer< CONCRETE >::ACE_Based_Pointer | ( | CONCRETE * | initial | ) |

| Initialize this object using the <initial> pointer. See constructor for <ACE_Based_Pointer_Basic> for details.

template<class CONCRETE>
ACE_Based_Pointer< CONCRETE >::ACE_Based_Pointer | ( | const void * | base_addr,
|  | int | dummy
| ) |

| Initialize this object with known <base_addr>. <dummy> is a dummy value used to resolve overload ambiguity and it otherwise ignored.

template<class CONCRETE>
ACE_Based_Pointer< CONCRETE >::ACE_Based_Pointer | ( | const ACE_Based_Pointer< CONCRETE > & | rhs | ) |

| Copy constructor (not implemented yet).

## Member Function Documentation

template<class CONCRETE>
ACE_INLINE CONCRETE * ACE_Based_Pointer< CONCRETE >::operator-> | ( | void |  | ) |

| The C++ "delegation operator".

template<class CONCRETE>
ACE_INLINE void ACE_Based_Pointer< CONCRETE >::operator= | ( | CONCRETE * | rhs | ) |

| Pseudo-assignment operator. Reimplemented from ACE_Based_Pointer_Basic.

template<class CONCRETE>
ACE_INLINE void ACE_Based_Pointer< CONCRETE >::operator= | ( | const ACE_Based_Pointer< CONCRETE > & | rhs | ) |

| Assignment operator.

The documentation for this class was generated from the following files:

- Based_Pointer_T.h
- Based_Pointer_T.cpp
- Based_Pointer_T.i